package com.jasamedika.medifirst2000.entities;

import java.io.Serializable;
import org.hibernate.envers.Audited;
import javax.persistence.*;

import org.hibernate.validator.constraints.NotEmpty;

import com.jasamedika.medifirst2000.base.BaseMaster;
import javax.validation.constraints.NotNull;
import org.hibernate.validator.constraints.Length;
import org.hibernate.validator.internal.util.logging.Messages;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonManagedReference;
import com.jasamedika.medifirst2000.base.BaseMaster;
import com.jasamedika.medifirst2000.helper.Caption;
import org.hibernate.envers.Audited;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;

/**
 * class BentukProduk
 * 
 * @author Generator
 */
@Entity // @Audited
@Table(name = "BentukProduk_M")
@JsonIgnoreProperties({ "hibernateLazyInitializer", "handler" })
public class BentukProduk extends BaseMaster {
	@NotNull(message = "Kd Bentuk Produk tidak boleh kosong")
	@Column(name = "KdBentukProduk", nullable = false)
	@Caption(value = "Kode Bentuk Produk")
	private Byte kdBentukProduk;

	public void setKdBentukProduk(Byte kdBentukProduk) {
		this.kdBentukProduk = kdBentukProduk;
	}

	public Byte getKdBentukProduk() {
		return this.kdBentukProduk;
	}

	@ManyToOne
	@JoinColumn(name = "ObjectDepartemenFk")
	@NotNull(message = "Kd Departemen tidak boleh kosong")

	@Caption(value = "Object Departemen")
	private Departemen departemen;

	public void setDepartemen(Departemen departemen) {
		this.departemen = departemen;
	}

	public Departemen getDepartemen() {
		return this.departemen;
	}

	@Column(name = "ObjectDepartemenFk", insertable = false, updatable = false)
	private Integer departemenId;

	@ManyToOne
	@JoinColumn(name = "ObjectKelompokProdukFk")

	@Caption(value = "Object Kelompok Produk")
	private KelompokProduk kelompokProduk;

	public void setKelompokProduk(KelompokProduk kelompokProduk) {
		this.kelompokProduk = kelompokProduk;
	}

	public KelompokProduk getKelompokProduk() {
		return this.kelompokProduk;
	}

	@Column(name = "ObjectKelompokProdukFk", insertable = false, updatable = false, nullable = false)
	private Integer kelompokProdukId;

	@NotNull(message = "Nama Bentuk Produk tidak boleh kosong")
	@Column(name = "NamaBentukProduk", nullable = false, length = 30)
	@Caption(value = "Nama Bentuk Produk")
	private String namaBentukProduk;

	public void setNamaBentukProduk(String namaBentukProduk) {
		this.namaBentukProduk = namaBentukProduk;
	}

	public String getNamaBentukProduk() {
		return this.namaBentukProduk;
	}

	@NotNull(message = "QBentuk Produk tidak boleh kosong")
	@Column(name = "QBentukProduk", nullable = false)
	@Caption(value = "QBentuk Produk")
	private Byte qBentukProduk;

	public void setqBentukProduk(Byte qBentukProduk) {
		this.qBentukProduk = qBentukProduk;
	}

	public Byte getqBentukProduk() {
		return this.qBentukProduk;
	}

	@Id
	@GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "public.bentukproduk_m_id_seq")
	@javax.persistence.SequenceGenerator(name = "public.bentukproduk_m_id_seq", sequenceName = "public.bentukproduk_m_id_seq", allocationSize = 1)
	@Column(name = "id")
	protected Integer id;

	public Integer getId() {

		return id;
	}

	public void setId(Integer id) {
		this.id = id;
	}
}